/*############################################################################
#                                                                            #
#             VAEEP-ROM AT93C46D hCo(8BITp)                    #
#                                                                            #
#@RpCmFFAVR studio 4.18(SP3) + WinAVR-20100110                #
#                                                                            #
#@F                                                                    #
#    {IC8bit[h16[h2ނT|[gĂ邪{hCoł     #
#    8rbg[ĥ݂ɑΉĂB                                       #
#    ]āAORG[qLow(GND)ɂKvB                             #
#    ܂ACS[q̓v_EĂSƎvB                  #
#@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@#
#@@HdqʏMACAhXݍϕĩf[^ȉɎB             #
#           +0 +1 +2 +3 +4 +5 +6 +7 +8 +9 +A +B +C +D +E +F 10 11            #
#    0000 : 40 00 10 00 00 02 CD xx xx xx 00 00 00 00 00 00 00 00            #
#    擪4oCgMACAhXʎqi40-00-10-00 Œj		             	 #
#    3oCg̓x_[ID(00-02-CD)										 #
#    3oCg̓VAԍ(xx-xx-xx)									 #
#    8oCg0Ŗ߂Ă											 #
#    MACAhX̓x_[ID + VAԍ6oCgł                   #
#@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@#
#    ڑj SI  ---  PB3                                                   #
#             SO  ---  PB4                                                   #
#             SK  ---  PB5                                                   #
#             CS  ---  PB2                                                   #
#             ORG ---  GND                                                   #
#                                                  2012/11/25 Create by nPYO #
############################################################################*/
#ifndef __AT93C46D_H__
#define __AT93C46D_H__

#include <avr/io.h>

#ifdef __AT93C46D_C__

	/************************************************************************/
	/* 		@@@@@@@@[U[`		                    */
	/* @@@@@@@@gpɍ킹Đݒ肷邱	                    */
	/************************************************************************/
	#define USE_WRITE_FUNC 0

	/* SPI[hI				*/
	#define EEP_SPI_MODE 1			/* 0:soft 1:SPIport 2:USART0 3:USART1	*/

	/* CS|[g`				*/
	#define EEP_CS_PIN PINB
	#define EEP_CS_BIT 2

	/* SI|[g`					*/
	#define EEP_SI_PIN PINB
	#define EEP_SI_BIT 3

	/* SO|[g`					*/
	#define EEP_SO_PIN PINB
	#define EEP_SO_BIT 4

	/* SCK|[g`				*/
	#define EEP_SCK_PIN PINB
	#define EEP_SCK_BIT 5

	/************************************************************************/
	/* 		@@@@@@@@[U[`܂		                    */
	/* @@@@@@@@@@@@ȉ͕ύXs								*/
	/************************************************************************/

#endif

	/*	֐vg^Cv錾			*/
	void at93c46_init( void );
	uint8_t at93c46_read_byte( uint8_t addr );
	void at93c46_write_byte( uint8_t addr ,uint8_t data );
	void at93c46_ewen( void );
	void at93c46_ewds( void );

#endif
