/*###########################################################################
#                                                                           #
#                          HTTPT[o[x                                 #
#                                                                           #
###########################################################################*/
#define __HTTPS_C__

#include <stdio.h>
#include <string.h>

#include <avr/pgmspace.h>
#include <avr/io.h>

#include "net.h"
#include "../myutil/string_func.h"
#include "socket.h"
#include "https.h"

/*****************************************************************************
*                    HTTPT[o[xiGETR}ĥ݁j
* Fvoid
* ߒlFvoid
* R}hM "void http_process( char *cmd ,void *tmp )" Ăяo
*   *cmd ɂ GETR}hp[^i[Ă
*   *tmp ͌ĂяoŎgpłꎞobt@
*  @Ăяo*cmdobt@f[^jĂȂ
*    eobt@TCY HTTPS_BUF_SIZE ł
*    *cmd*tmp͘Äɂ邽߁Acmd[HTTPS_BUF_SIZE * 2 ]܂ŗpłB
*****************************************************************************/
void https_task( void )
{
	char *p1 ,*p2;
	char workspace[ HTTPS_BUF_SIZE * 2 ];
	char *cmd = &workspace[ 0 ];
	char *rBuf = &workspace[ HTTPS_BUF_SIZE ];

	uint16_t line = 0;
	uint8_t getFlag = 0;
	uint8_t ret;

	/* M`FbN				*/
	if ( !tcp_isAccept( HTTPS_SOCK ,HTTPS_PORT ) ) {
		return;
	}

	/* NGXgbZ[WM				*/
	while ( 1 ) {

		/* 1sM							*/
		ret = tcp_gets( HTTPS_SOCK ,HTTPS_BUF_SIZE ,rBuf );
		if ( ret || ( rBuf[0] == '\0' ) ) {
			break;
		}

		/* 擪s̃R}h				*/
		if ( ++line == 1 ) {
			if ( ( p1 = strcasestr_P( rBuf ,PSTR("GET ") ) ) == rBuf ) {	/* GET ?			*/
				p1 += 4;
				if ( ( p2 = strcasestr_P( p1 ,PSTR(" HTTP/1.") ) ) != NULL ) {
					*p2 = '\0';
					strcpy_s( cmd ,HTTPS_BUF_SIZE ,p1 );
					getFlag = 1;
				}
			}
		}

		/* NGXgeLXgʂ`FbN	*/
		if ( line > 10 ) {						/* XGXgeLXg10sȏ̏ꍇ͋ؒf	*/
			tcp_disconnect( HTTPS_SOCK );
			return;
		}
	}

	/* GETR}hs				*/
	if ( getFlag ) {

		/* HTTP 			*/
		http_process( cmd ,rBuf );
	}

	/* ڑؒf						*/
	tcp_disconnect( HTTPS_SOCK );
}
