/*###########################################################################
#                                                                           #
#                           NTPNCAg                                 #
#                                                                           #
# Ql) http://wiki.livedoor.jp/yamamaya_com/                               #
#       http://wiki.livedoor.jp/yamamaya_com/d/NTP%bb%fe%b7%d7ver.1         #
#                                                                           #
#                                                                           #
###########################################################################*/
#ifndef __NTPC_H__
#define __NTPC_H__

#include <avr/io.h>

/* NTCP`						*/
#define NTPC_NEXT_TIME ( 8UL * 360000LU )		/* ēԊu(8)			*/
#define NTPC_ADJ 0			/* `x␳ 0:Ȃ 1:L						*/
#define NTPC_TIMER_NUM 1	/* `x␳^C}[ԍ(16bit^C}[)	*/

/* \					*/
typedef struct TIME_t {
	uint16_t year;
	uint8_t  month;
	uint8_t  day;
	uint8_t	 wday;
	uint8_t	 hour;
	uint8_t  minute;
	uint8_t  second;
} TIME;

/* NTPCǗ\				*/
typedef struct NTPC_INFO_t {
	volatile uint32_t ip;					/* NTPT[o[AhX			*/
	volatile uint32_t timeout;
	volatile uint32_t systemTime;
	uint32_t lastUpdate;
	volatile uint8_t ms10Count;				/* 10msecJE^				*/
} NTPC_INFO;

/* ֐vg^Cv錾			*/
void ntpc_timer( void );
void ntpc_init( void );
void ntpc_task( void );
uint32_t ntpc_getTime( TIME *t );
void ntpc_setTime( TIME *t );
uint32_t ntpc_getLastUpdate( TIME *t );
uint32_t ntpc_getSerial( TIME *t );
void ntpc_setTimeStruct( uint32_t ts ,TIME *t );

#endif
