/*###########################################################################
#                                                                           #
#                       WIZ W5100 䃂W[                            #
#																			#
#                             WIZЌJ́uW5100 driver v1.5vx[X      #
#												          PPPOE͖T|[g #
#                                                                           #
#  W5100݂̊gpꍇAVRINTn֐ڑ(PCINT͖Ή)          #
#                                                                           #
#                            2012/11/27 SPI[hł̃oCg[h̃oOC #
###########################################################################*/
#ifndef __W5100_H__
#define __W5100_H__

/* eCN[h											*/
#include <avr/io.h>
#include <avr/pgmspace.h>

/*															*/
/* O[(SPIpS-RAM23K256gp邩Ȃ)		*/
/*															*/
#define WIZ_USE_SPI_SRAM 0						/* 0:gp 1:gp			*/

/*															*/
/*	W5100 Zbg|[g`								*/
/*															*/
#define W5100_RESET_PIN PINB
#define W5100_RESET_BIT 0

/*															*/
/* ڑoX^Cv`(ύXs)								*/
/*															*/
#define __DEF_IINCHIP_DIRECT_MODE__   1			/* _CNg[h			*/
#define __DEF_IINCHIP_INDIRECT_MODE__ 2			/* C_CNg[h		*/
#define __DEF_IINCHIP_SPI_MODE__      3			/* SPI[h				*/

/*															*/
/* ڑoX^Cvݒ										*/
/*															*/
//#define __DEF_IINCHIP_BUS__ __DEF_IINCHIP_DIRECT_MODE__
//#define __DEF_IINCHIP_BUS__ __DEF_IINCHIP_INDIRECT_MODE__
#define __DEF_IINCHIP_BUS__ __DEF_IINCHIP_SPI_MODE__

/*															*/
/* gp荞ݔԍ(INT0`INT7)` ( -1 == ݖgp )	*/
/*															*/
//#define __DEF_IINCHIP_INT__ 7
#define __DEF_IINCHIP_INT__ -1

/*															*/
/* _CNg[hpݒiɍ킹邱)			*/
/*															*/
#if ( __DEF_IINCHIP_BUS__ == __DEF_IINCHIP_DIRECT_MODE__ )
#ifdef __W5100_C__
#define __DEF_IINCHIP_MAP_BASE__ 0x8000			/* }bsO擪AhX	*/
#endif	// #ifdef __W5100_C__

/*															*/
/* C_CNg[hpݒiɍ킹邱)		*/
/*															*/
#elif ( __DEF_IINCHIP_BUS__ == __DEF_IINCHIP_INDIRECT_MODE__ )
#ifdef __W5100_C__
#define IDM_OR  0x8000							/* OR(MR)WX^AhX	*/
#define IDM_AR0 0x8001							/* AR0WX^AhX		*/
#define IDM_AR1 0x8002							/* AR1WX^AhX		*/
#define IDM_DR  0x8003							/* DRWX^AhX		*/
#endif	// #ifdef __W5100_C__

/*															*/
/* SPI[hpݒ										*/
/*															*/
#elif ( __DEF_IINCHIP_BUS__ == __DEF_IINCHIP_SPI_MODE__ )

/* SPI|[gݒ					*/
#ifdef __W5100_C__

#define SPI_TYPE 1								/* 0:soft 1:SPIport 2:USART0 3:USART1	*/

#define SPI_MOSI_PIN  PINB						/* MOSIɊ蓖Ă|[g				*/
#define SPI_MOSI_BIT  3							/* MOSIɊ蓖Ă|[g̃rbgԍ	*/

#define SPI_MISO_PIN  PINB						/* MISOɊ蓖Ă|[g				*/
#define SPI_MISO_BIT  4							/* MISOɊ蓖Ă|[g̃rbgԍ	*/

#define SPI_SCK_PIN   PINB						/* SCKɊ蓖Ă|[g				*/
#define SPI_SCK_BIT   5							/* SCKɊ蓖Ă|[g̃rbgԍ	*/

#define SPI_SCS_PIN   PINB						/* #SCSɊ蓖Ă|[g				*/
#define SPI_SCS_BIT   1							/* #SCSɊ蓖Ă|[g̃rbgԍ	*/

#endif // #ifdef __W5100_C__

#else
#error "unknown bus type"
#endif

/* MRWX^l`										*/
#ifdef __W5100_C__
#define MR_RST				0x80			/* reset													*/
#define MR_PB				0x10			/* ping block												*/
#define MR_LB 				0x04			/* little or big endian selector in indirect mode			*/
#define MR_AI				0x02			/* auto-increment in indirect mode							*/
#define MR_IND				0x01			/* enable indirect mode										*/
#endif	// #ifdef __W5100_C__

/* IRWX^l`										*/
#ifdef __W5100_C__
#define IR_CONFLICT			0x80			/* check ip confict											*/
#define IR_UNREACH			0x40			/* get the destination unreachable message in UDP sending	*/
#endif	// #ifdef __W5100_C__

/* oX^Cvɉx[XAhX̐ݒ	*/
#ifdef __W5100_C__
#if ( __DEF_IINCHIP_BUS__ == __DEF_IINCHIP_DIRECT_MODE__ )
#define MR __DEF_IINCHIP_MAP_BASE__
#define COMMON_BASE __DEF_IINCHIP_MAP_BASE__

#elif ( __DEF_IINCHIP_BUS__ == __DEF_IINCHIP_INDIRECT_MODE__ )
#define MR IDM_OR
#define COMMON_BASE 0x0000

#else
#include "../myutil/spi_func.h"
#define MR 0x0000
#define COMMON_BASE 0x0000
#endif
#endif	// #ifdef __W5100_C__

/* Mobt@擪AhX`						*/
#ifdef __W5100_C__
#define __DEF_IINCHIP_MAP_TXBUF__ ( COMMON_BASE + 0x4000 )
#define __DEF_IINCHIP_MAP_RXBUF__ ( COMMON_BASE + 0x6000 )
#endif	// #ifdef __W5100_C__

/* \PbgWX^擪AhX^\PbgWX^TCY	*/
#ifdef __W5100_C__
#define CH_BASE			( COMMON_BASE + 0x0400 )				/* \PbgOWX^擪AhX						*/
#define CH_SIZE			0x0100									/* e\PbgWX^TCY								*/
#endif	// #ifdef __W5100_C__

/* e탌WX^AhX`								*/
#ifdef __W5100_C__

#define GAR0			( COMMON_BASE + 0x0001 )				/* Gateway IP Register									*/
#define SUBR0			( COMMON_BASE + 0x0005 )				/* Subnet mask Register									*/
#define SHAR0			( COMMON_BASE + 0x0009 )				/* Source MAC Register									*/
#define SIPR0			( COMMON_BASE + 0x000F )				/* Source IP Register									*/
#define IR				( COMMON_BASE + 0x0015 )				/* Interrupt Register									*/
#define IMR				( COMMON_BASE + 0x0016 )				/* Interrupt mask register								*/
#define RTR0			( COMMON_BASE + 0x0017 )				/* Timeout register ( 1 is 100usec)						*/
#define RCR				( COMMON_BASE + 0x0019 )				/* Retry count reigster									*/
#define RMSR			( COMMON_BASE + 0x001A )				/* Receive memory size reigster							*/
#define TMSR			( COMMON_BASE + 0x001B )				/* Transmit memory size reigster						*/
#define UIPR0			( COMMON_BASE + 0x002A )				/* Unreachable IP register address in UDP mode			*/
#define UPORT0			( COMMON_BASE + 0x002E )				/* Unreachable Port register address in UDP mode		*/

#define Sn_MR(ch)		( CH_BASE + ch * CH_SIZE + 0x0000 )		/* socket Mode register									*/
#define Sn_CR(ch)		( CH_BASE + ch * CH_SIZE + 0x0001 )		/* channel Sn_CR register								*/
#define Sn_IR(ch)		( CH_BASE + ch * CH_SIZE + 0x0002 )		/* channel interrupt register							*/
#define Sn_SR(ch)		( CH_BASE + ch * CH_SIZE + 0x0003 )		/* channel status register								*/
#define Sn_PORT0(ch)	( CH_BASE + ch * CH_SIZE + 0x0004 )		/* source port register									*/
#define Sn_DHAR0(ch)	( CH_BASE + ch * CH_SIZE + 0x0006 )		/* Peer MAC register									*/
#define Sn_DIPR0(ch)	( CH_BASE + ch * CH_SIZE + 0x000C )		/* Peer IP register										*/
#define Sn_DPORT0(ch)	( CH_BASE + ch * CH_SIZE + 0x0010 )		/* Peer port register									*/
#define Sn_MSSR0(ch)	( CH_BASE + ch * CH_SIZE + 0x0012 )		/* Maximum Segment Size(Sn_MSSR0) register				*/
#define Sn_PROTO(ch)	( CH_BASE + ch * CH_SIZE + 0x0014 )		/* Protocol of IP Header field register in IP raw mode	*/
#define Sn_TOS(ch)		( CH_BASE + ch * CH_SIZE + 0x0015 )		/* IP Type of Service(TOS) Register 					*/
#define Sn_TTL(ch)		( CH_BASE + ch * CH_SIZE + 0x0016 )		/* Time to live(TTL) Register							*/
#define Sn_TX_FSR0(ch)	( CH_BASE + ch * CH_SIZE + 0x0020 )		/* Transmit free memory size register					*/
#define Sn_TX_RD0(ch)	( CH_BASE + ch * CH_SIZE + 0x0022 )		/* Transmit memory read pointer register				*/
#define Sn_TX_WR0(ch)	( CH_BASE + ch * CH_SIZE + 0x0024 )		/* Transmit memory write pointer register				*/
#define Sn_RX_RSR0(ch)	( CH_BASE + ch * CH_SIZE + 0x0026 )		/* Received data size register							*/
#define Sn_RX_RD0(ch)	( CH_BASE + ch * CH_SIZE + 0x0028 )		/* Read point of Receive memory							*/
#define Sn_RX_WR0(ch)	( CH_BASE + ch * CH_SIZE + 0x002A )		/* Write point of Receive memory						*/

#endif	// #ifdef __W5100_C__

/* Sn_MRWX^l`									*/
#define Sn_MR_CLOSE			0x00			/* unused socket											*/
#define Sn_MR_TCP			0x01			/* TCP														*/
#define Sn_MR_UDP			0x02			/* UDP														*/
#define Sn_MR_IPRAW			0x03			/* IP LAYER RAW SOCK										*/
#define Sn_MR_MACRAW		0x04			/* MAC LAYER RAW SOCK										*/
#define Sn_MR_ND			0x20			/* No Delayed Ack(TCP) flag									*/
#define Sn_MR_MULTI			0x80			/* support multicating										*/

/* Sn_CRWX^l`									*/
#define Sn_CR_OPEN			0x01			/* initialize or open socket								*/
#define Sn_CR_LISTEN		0x02			/* wait connection request in tcp mode(Server mode)			*/
#define Sn_CR_CONNECT		0x04			/* send connection request in tcp mode(Client mode)			*/
#define Sn_CR_DISCON		0x08			/* send closing reqeuset in tcp mode						*/
#define Sn_CR_CLOSE			0x10			/* close socket												*/
#define Sn_CR_SEND			0x20			/* updata txbuf pointer, send data							*/
#define Sn_CR_SEND_MAC		0x21			/* send data with MAC address, so without ARP process		*/
#define Sn_CR_SEND_KEEP		0x22			/*  send keep alive message									*/
#define Sn_CR_RECV			0x40			/* update rxbuf pointer, recv data							*/

/* Sn_IRWX^l`									*/
#define Sn_IR_SEND_OK		0x10			/* complete sending											*/
#define Sn_IR_TIMEOUT		0x08			/* assert timeout											*/
#define Sn_IR_RECV			0x04			/* receiving data											*/
#define Sn_IR_DISCON		0x02			/* closed socket											*/
#define Sn_IR_CON			0x01			/* established connection									*/

/* Sn_SRWX^l`									*/
#define SOCK_CLOSED			0x00			/* closed													*/
#define SOCK_INIT 			0x13			/* init state												*/
#define SOCK_LISTEN			0x14			/* listen state												*/
#define SOCK_SYNSENT	   	0x15			/* connection state											*/
#define SOCK_SYNRECV		0x16			/* connection state											*/
#define SOCK_ESTABLISHED	0x17			/* success to connect										*/
#define SOCK_FIN_WAIT		0x18			/* closing state											*/
#define SOCK_CLOSING		0x1A			/* closing state											*/
#define SOCK_TIME_WAIT		0x1B			/* closing state											*/
#define SOCK_CLOSE_WAIT		0x1C			/* closing state											*/
#define SOCK_LAST_ACK		0x1D			/* closing state											*/
#define SOCK_UDP			0x22			/* udp socket												*/
#define SOCK_IPRAW			0x32			/* ip raw mode socket										*/
#define SOCK_MACRAW			0x42			/* mac raw mode socket										*/

/* IP PROTOCOL */
#define IPPROTO_IP              0           /* Dummy for IP												*/
#define IPPROTO_ICMP            1           /* Control message protocol									*/
#define IPPROTO_IGMP            2           /* Internet group management protocol						*/
#define IPPROTO_GGP             3           /* Gateway^2 (deprecated)									*/
#define IPPROTO_TCP             6           /* TCP														*/
#define IPPROTO_PUP             12          /* PUP														*/
#define IPPROTO_UDP             17          /* UDP														*/
#define IPPROTO_IDP             22          /* XNS idp													*/
#define IPPROTO_ND              77          /* UNOFFICIAL net disk protocol								*/
#define IPPROTO_RAW             255         /* Raw IP packet											*/

/* ő\Pbg`(ύXs)							*/
#define	MAX_SOCK_NUM 4

/* ϐ^`											*/
typedef uint8_t SOCKET;

/* ֐vg^Cv錾			*/
#if WIZ_USE_SPI_SRAM
#include "../23k256/23k256.h"
void ss_memcpy_WIZ( SSMP buf ,uint16_t addr ,uint16_t len );
void wiz_memcpy_SS( uint16_t addr ,SSMP buf ,uint16_t len );
#endif

void wiz_write_byte( uint16_t addr ,uint8_t data );
uint8_t wiz_read_byte( uint16_t addr );
void wiz_memcpy( uint16_t addr ,void *buf ,uint16_t len );
void wiz_memcpy_P( uint16_t addr ,const prog_void *buf ,uint16_t len );
void memcpy_WIZ( void *buf ,uint16_t addr ,uint16_t len );
void wiz_write_word( uint16_t addr ,uint16_t val );
uint16_t wiz_read_word( uint16_t addr );
void wiz_setSnIR( SOCKET sok ,uint8_t ir );
uint8_t wiz_getSnIR( SOCKET sok );
uint16_t wiz_getIINCHIP_RxMAX( SOCKET sok );
uint16_t wiz_getIINCHIP_TxMAX( SOCKET sok );
uint16_t wiz_getIINCHIP_RxMASK( SOCKET sok );
uint16_t wiz_getIINCHIP_TxMASK( SOCKET sok );
uint16_t wiz_getIINCHIP_RxBASE( SOCKET sok );
uint16_t wiz_getIINCHIP_TxBASE( SOCKET sok );
void wiz_iinchip_init( void );
void wiz_sysinit( uint8_t tx_size ,uint8_t rx_size );

void wiz_setMR( uint8_t val );

void wiz_setSHAR( uint8_t *addr );
void wiz_getSHAR( uint8_t *addr );

void wiz_setSIPR( uint8_t *addr );
void wiz_getSIPR( uint8_t *addr );

void wiz_setGAR( uint8_t *addr );
void wiz_getGAR( uint8_t *addr );

void wiz_setSUBR( uint8_t *addr );
void wiz_getSUBR( uint8_t *addr );

void wiz_setIMR( uint8_t val );
uint8_t wiz_getIMR( void );

void wiz_setSn_MR( SOCKET sok ,uint8_t val );
uint8_t wiz_getSn_MR( SOCKET sok );

void wiz_setSn_SPORT( SOCKET sok ,uint16_t port );
uint16_t wiz_getSn_SPORT( SOCKET sok );

void wiz_setSn_DHAR( SOCKET sok ,uint8_t *addr );
void wiz_getSn_DHAR( SOCKET sok ,uint8_t *addr );

void wiz_setSn_DIPR( SOCKET sok ,uint8_t *addr );
void wiz_getSn_DIPR( SOCKET sok ,uint8_t *addr );

void wiz_setSn_DPORT( SOCKET sok ,uint16_t port );
uint16_t wiz_getSn_DPORT( SOCKET sok );

void wiz_setSn_MSS( SOCKET sok ,uint16_t mss );
uint16_t wiz_getSn_MSS( SOCKET sok );

void wiz_setSn_TTL( SOCKET sok ,uint8_t ttl );
uint8_t wiz_getSn_TTL( SOCKET sok );

void wiz_setSn_PROTO( SOCKET sok ,uint8_t prto );
uint8_t wiz_getSn_PROTO( SOCKET sok );

void wiz_setSn_RX_RD( SOCKET sok ,uint16_t rp );
uint16_t wiz_getSn_RX_RD( SOCKET sok );

void wiz_setSn_TX_WR( SOCKET sok ,uint16_t wp );
uint16_t wiz_getSn_TX_WR( SOCKET sok );

uint8_t wiz_getSn_SR( SOCKET sok );

uint16_t wiz_getSn_TX_FSR( SOCKET sok );
uint16_t wiz_getSn_RX_RSR( SOCKET sok );

void wiz_sockCommand( SOCKET sok ,uint8_t cmd );

#endif	// #ifndef __W5100_H__
