/*###########################################################################
#                                                                           #
#        	  				HTTP										#
#                                                                           #
###########################################################################*/
#define __HTTP_C__
#include "project.h"

/* [Jϐ錾				*/
static uint8_t sendSts = 0;

/* [J֐vg^Cv錾	*/
static void html_index( char *pCmd );
static void html_ddns( char *pCmd );
static uint8_t html_textEdit( char *data ,uint8_t buffer_size ,const prog_char *label ,char *pCmd );

static uint8_t getCommandItem( char *pCmd ,const char *name ,uint16_t size ,char *buf );
static void sends_P( const prog_char *txt );
static void sends( char *txt );

static void decode( char *txt );

/*****************************************************************************
*							HTTPR}h
* Fchar *cmd R}h
*		void *tmp Ɨp̈
* ߒlFvoid
*
*   *cmd R}hp[^i[Ă
*   *tmp ͈ꎞobt@
*   *cmd,*tmpɎRɏėǂB
*   eobt@TCY HTTPS_BUF_SIZE łB
*   *cmd*tmp͘Äɂ邽߁Acmd[HTTPS_BUF_SIZE * 2 ]܂ŗpłB
*****************************************************************************/
void http_process( char *cmd ,void *tmp )
{
	char *p1;
	uint16_t len;
	uint8_t eepUpdate = 0;

	sendSts = 0;

	/* p[^`FbN			*/
	len = strlen( cmd );
	if ( !len ) {
		return;
	}

	p1 = strchr( cmd ,'?' );
	if ( p1 ) {
		*p1++ = '\0';
	} else {
		p1 = &cmd[ len - 1 ];
	} 

	/* bZ[WM			*/
	sends_P( PSTR("HTTP/1.1 200 OK\r\n"
			 	  "Content-Type: text/html\r\n"
				  "Connection: Close\r\n"
				  "\r\n")
	);

	/* HTMLwb_M				*/
	sends_P( PSTR("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">"
				  "<html lang=\"ja\">"
			      "<head>"
				  "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=Shift_JIS\">"
				  "<meta http-equiv=\"Content-Style-Type\" content=\"text/css\">"
				  "<title>WOL</title>"
				  "</head>"
				  "<body>"
				  "<p><font size=\"+2\"><b><a href=\"/\" target=\"_self\">"	)
	);

	sends_P( project_title );
	sends_P( PSTR("</a></b></font></p>") );
	
	/* e						*/
	if ( !strcmp_P( cmd ,PSTR("/") ) || !strcasecmp_P( cmd ,PSTR("/index.html") ) ) {
		html_index( cmd );

	} else if ( !strcasecmp_P( cmd ,PSTR("/ddns.html") ) ) {
		html_ddns( cmd );
		eep_write_netInfo();

	} else if ( !strcasecmp_P( cmd ,PSTR("/host.html") ) ) {
		eepUpdate = html_textEdit( netInfo.hostname ,sizeof(netInfo.hostname) ,PSTR("Host&nbsp;name") ,p1 );
		if ( eepUpdate ) {
			eep_write_netInfo();
		}

	} else if ( !strcasecmp_P( cmd ,PSTR("/ntp.html") ) ) {
		eepUpdate = html_textEdit( netInfo.ntpcName ,sizeof(netInfo.ntpcName) ,PSTR("NTP&nbsp;server&nbsp;name") ,p1 );
		if ( eepUpdate ) {
			eep_write_netInfo();
			ntpc_init();
		}

	} else if ( !strcasecmp_P( cmd ,PSTR("/edit_ipurl.html") ) ) {
		char *p = (char *)tmp;
		eep_read_remote_check_url( p ,URL_SIZE );
		eepUpdate = html_textEdit( p ,URL_SIZE ,PSTR("Remote&nbsp;IP&nbsp;address&nbsp;check&nbsp;url") ,p1 );
		if ( eepUpdate ) {
			eep_write_remote_check_url( p );
			netInfo.ddnsLastCheck = 0L;
			netInfo.ddnsLastCheck_sts = 0;
			netInfo.checkIpAddress = 0L;
		}

	} else if ( !strcasecmp_P( cmd ,PSTR("/edit_ddnsurl.html") ) ) {
		char *p = (char *)tmp;
		eep_read_ddns_update_url( p ,URL_SIZE );
		eepUpdate = html_textEdit( p ,URL_SIZE ,PSTR("DDNS&nbsp;update&nbsp;url") ,p1 );
		if ( eepUpdate ) {
			eep_write_ddns_update_url( p );
			netInfo.ddnsLastCheck = 0L;
			netInfo.ddnsLastCheck_sts = 0;
			netInfo.checkIpAddress = 0L;
			netInfo.ddnsLastUpdateIpAddress = 0L;
			netInfo.ddnsLastUpdate = 0L;
			netInfo.ddnsLastUpdate_sts = 0;
		}
	}

	/* HTMLtb^[M		*/
	sends_P( PSTR("</body></html>") );
}

/*****************************************************************************
*								index.html
* Fchar *pCmd  R}hւ̃|C^
* ߒlFvoid
*****************************************************************************/
static void html_index( char *pCmd )
{
	struct _local {
		char msg[ ( HTTPS_BUF_SIZE * 2 ) - 24 - 24 - 48 - 48 - sizeof(TIME) - 4 ];
		char txt4[ 24 ];
		char txt3[ 24 ];
		char txt2[ 48 ];
		char txt1[ 48 ];
		TIME t;
		uint32_t tim;
	} *lp = (struct _local *)pCmd;

	static const prog_char fmt_table_title[] = "<TABLE border=\"1\" ><TBODY><TR><TD width=\"300\"><B><FONT color=\"#0000ff\">&nbsp;%s</FONT></B></TD><TD width=\"300\">&nbsp;</TD><TD width=\"70\">&nbsp;</TD></TR>";
	static const prog_char table_end[] = "</TBODY></TABLE><BR>";

	static const prog_char fmt_linkRow[] = "<TR><TD>&nbsp;%s</TD><TD>&nbsp;%s</TD><TD><div style=\"text-align:center\"><A href=\"%s\" target=\"_self\" style=\"text-decoration:none;\">%s</A></div></TD></TR>";
	static const prog_char fmt_textRow[] = "<TR><TD>&nbsp;%s</TD><TD>&nbsp;%s</TD><TD>&nbsp;</TD></TR>";

	static const prog_char txt_Change[] = "Change";
	static const prog_char txt_Edit[] = "Edit";

	static const prog_char fmt_time[] = "%04u/%02u/%02u&nbsp;%02u:%02u:%02u";

	static const prog_char txt_time_void[] = "----/--/--&nbsp;--:--:--";

	static const prog_char non_ip_address[] = "---.---.---.---";

	/*								*/
	/* WOL֘A̐ݒ			*/
	/*								*/
	strcpy_s_P( lp->txt1 ,sizeof(lp->txt1) ,PSTR("WAN") );
	sprintf_P( lp->msg ,fmt_table_title ,lp->txt1 );
	sends( lp->msg );

	/* WANIPAhX				*/
	strcpy_s_P( lp->txt1 ,sizeof(lp->txt1) ,PSTR("IP&nbsp;address") );
	if ( netInfo.checkIpAddress == 0L ) {
		strcpy_s_P( lp->txt2 ,sizeof(lp->txt2) ,non_ip_address );
	} else {
		inet_ntoa( lp->txt2 ,netInfo.checkIpAddress );
	}
	sprintf_P( lp->msg ,fmt_textRow ,lp->txt1 ,lp->txt2 );
	sends( lp->msg );

	/* WOLgp|[gԍ			*/
	strcpy_s_P( lp->txt1 ,sizeof(lp->txt1) ,PSTR("Port&nbsp;number") );
	sprintf_P( lp->txt2 ,PSTR("%u") ,netInfo.wolPort );
	sprintf_P( lp->msg ,fmt_textRow ,lp->txt1 ,lp->txt2 );
	sends( lp->msg );

	sends_P( table_end );

	/*								*/
	/* {̂̐ݒ				*/
	/*								*/
	strcpy_s_P( lp->txt1 ,sizeof(lp->txt1) ,PSTR("LAN") );
	sprintf_P( lp->msg ,fmt_table_title ,lp->txt1 );
	sends( lp->msg );

	/* MACAhX					*/
	strcpy_s_P( lp->txt1 ,sizeof(lp->txt1) ,PSTR("MAC&nbsp;address") );
	sprintf_P( lp->txt2 ,PSTR("%02x-%02x-%02x-%02x-%02x-%02x") ,netInfo.mac[0] ,netInfo.mac[1] ,netInfo.mac[2] ,netInfo.mac[3] ,netInfo.mac[4] ,netInfo.mac[5] );
	sprintf_P( lp->msg ,fmt_textRow ,lp->txt1 ,lp->txt2 );
	sends( lp->msg );

	/* zXg						*/
	strcpy_s_P( lp->txt1 ,sizeof(lp->txt1) ,PSTR("Host&nbsp;name") );
	strcpy_s_P( lp->txt2 ,sizeof(lp->txt2) ,PSTR("host.html") );
	strcpy_s_P( lp->txt3 ,sizeof(lp->txt3) ,txt_Edit );
	sprintf_P( lp->msg ,fmt_linkRow ,lp->txt1 ,netInfo.hostname ,lp->txt2 ,lp->txt3 );
	sends( lp->msg );

	/* [JIPAhX			*/
	strcpy_s_P( lp->txt1 ,sizeof(lp->txt1) ,PSTR("IP&nbsp;address") );
	inet_ntoa( lp->txt2 ,netInfo.ip );
	sprintf_P( lp->msg ,fmt_textRow ,lp->txt1 ,lp->txt2 );
	sends( lp->msg );

	/* Tulbg}XN				*/
	strcpy_s_P( lp->txt1 ,sizeof(lp->txt1) ,PSTR("Sub&nbsp;net&nbsp;mask") );
	inet_ntoa( lp->txt2 ,netInfo.subnet );
	sprintf_P( lp->msg ,fmt_textRow ,lp->txt1 ,lp->txt2 );
	sends( lp->msg );

	/* [^[						*/
	strcpy_s_P( lp->txt1 ,sizeof(lp->txt1) ,PSTR("Router&nbsp;IP&nbsp;address") );
	inet_ntoa( lp->txt2 ,netInfo.gateway );
	sprintf_P( lp->msg ,fmt_textRow ,lp->txt1 ,lp->txt2 );
	sends( lp->msg );

	/* DNS							*/
	strcpy_s_P( lp->txt1 ,sizeof(lp->txt1) ,PSTR("DNS&nbsp;IP&nbsp;address") );
	inet_ntoa( lp->txt2 ,netInfo.dns );
	sprintf_P( lp->msg ,fmt_textRow ,lp->txt1 ,lp->txt2 );
	sends( lp->msg );

	/* DHCP[h					*/
	strcpy_s_P( lp->txt1 ,sizeof(lp->txt1) ,PSTR("DHCP&nbsp;client") );
	if ( netInfo.dhcpMode == IP_STATIC ) {
		strcpy_s_P( lp->txt2 ,sizeof(lp->txt2) ,PSTR("OFF") );
	} else {
		strcpy_s_P( lp->txt2 ,sizeof(lp->txt2) ,PSTR("ON") );
	}
	sprintf_P( lp->msg ,fmt_textRow ,lp->txt1 ,lp->txt2 );
	sends( lp->msg );

	/* [X				*/
	if ( netInfo.dhcpMode != IP_STATIC ) {
		strcpy_s_P( lp->txt1 ,sizeof(lp->txt1) ,PSTR("DHCP&nbsp;lease&nbsp;time&nbsp;limit") );
		if ( dhcpInfo.leaseTime == 0xffffffff ) {
			strcpy_s_P( lp->txt2 ,sizeof(lp->txt2) ,PSTR("Unrestricted") );
		} else if ( ntpcInfo.lastUpdate ) {
			lp->tim = ntpcInfo.systemTime + dhcpInfo.ipTimer;
			ntpc_setTimeStruct( lp->tim ,&lp->t );
			sprintf_P( lp->txt2 ,fmt_time ,lp->t.year ,lp->t.month ,lp->t.day ,lp->t.hour ,lp->t.minute ,lp->t.second );
		} else {
			sprintf_P( lp->txt2 ,PSTR("%u:%02u:%02u") ,(uint16_t)( dhcpInfo.ipTimer / 3600L ) ,(uint16_t)( ( dhcpInfo.ipTimer % 3600L ) / 60L ) ,(uint16_t)( dhcpInfo.ipTimer % 60L ) );
		}
		sprintf_P( lp->msg ,fmt_textRow ,lp->txt1 ,lp->txt2 );
		sends( lp->msg );
	}

	sends_P( table_end );

	/*								*/
	/* NTP						*/
	/*								*/
	strcpy_s_P( lp->txt1 ,sizeof(lp->txt1) ,PSTR("NTP&nbsp;client") );
	sprintf_P( lp->msg ,fmt_table_title ,lp->txt1 );
	sends( lp->msg );

	/* NTPT[o[				*/
	strcpy_s_P( lp->txt1 ,sizeof(lp->txt1) ,PSTR("Server&nbsp;name") );
	strcpy_s_P( lp->txt2 ,sizeof(lp->txt2) ,PSTR("ntp.html") );
	strcpy_s_P( lp->txt3 ,sizeof(lp->txt3) ,txt_Edit );
	sprintf_P( lp->msg ,fmt_linkRow ,lp->txt1 ,netInfo.ntpcName ,lp->txt2 ,lp->txt3 );
	sends( lp->msg );

	/* NTPŏIAbvf[g			*/
	sends_P( PSTR("<TR><TD>&nbsp;Last&nbsp;update</TD><TD>&nbsp;") );
	if ( ntpcInfo.lastUpdate ) {
		ntpc_setTimeStruct( ntpcInfo.lastUpdate ,&lp->t );
		sprintf_P( lp->msg ,fmt_time ,lp->t.year ,lp->t.month ,lp->t.day ,lp->t.hour ,lp->t.minute ,lp->t.second );
		sends( lp->msg );
	} else {
		sends_P( txt_time_void );
	}
	sends_P( PSTR("</TD><TD>&nbsp;</TD></TR>") );

	sends_P( table_end );

	/*								*/
	/* DDNS						*/
	/*								*/
	strcpy_s_P( lp->txt1 ,sizeof(lp->txt1) ,PSTR("DDNS&nbsp;control") );
	sprintf_P( lp->msg ,fmt_table_title ,lp->txt1 );
	sends( lp->msg );

	/* DDNSgp^gp				*/
	strcpy_s_P( lp->txt1 ,sizeof(lp->txt1) ,PSTR("DDNS&nbsp;access") );
	if ( netInfo.ddnsMode == 0 ) {
		strcpy_s_P( lp->txt2 ,sizeof(lp->txt2) ,PSTR("Disable") );
	} else {
		strcpy_s_P( lp->txt2 ,sizeof(lp->txt2) ,PSTR("Enable") );
	}
	strcpy_s_P( lp->txt3 ,sizeof(lp->txt3) ,PSTR("ddns.html") );
	strcpy_s_P( lp->txt4 ,sizeof(lp->txt4) ,txt_Change );
	sprintf_P( lp->msg ,fmt_linkRow ,lp->txt1 ,lp->txt2 ,lp->txt3 ,lp->txt4 );
	sends( lp->msg );

	/* [gIPmFURL			*/
	eep_read_remote_check_url( lp->msg ,URL_SIZE );
	sends_P( PSTR("<TR><TD>&nbsp;Check&nbsp;remote&nbsp;IP&nbsp;url</TD><TD>&nbsp;") );
	sends( lp->msg );
	sends_P( PSTR("</TD><TD><div style=\"text-align:center\"><A href=\"edit_ipurl.html\" target=\"_self\" style=\"text-decoration:none;\">") );
	sends_P( txt_Edit );
	sends_P( PSTR("</A></div></TD></TR>") );

	/* [gIPŏI`FbN	*/
	sends_P( PSTR("<TR><TD>&nbsp;Last&nbsp;check&nbsp;date</TD><TD>&nbsp;") );
	if ( netInfo.ddnsLastCheck ) {
		ntpc_setTimeStruct( netInfo.ddnsLastCheck ,&lp->t );
		sprintf_P( lp->msg ,fmt_time ,lp->t.year ,lp->t.month ,lp->t.day ,lp->t.hour ,lp->t.minute ,lp->t.second );
		sends( lp->msg );
		if ( netInfo.ddnsLastCheck_sts == 2 ) {
			sends_P( PSTR("&nbsp;<B><FONT color=\"#ff0000\">(Failure&nbsp;!)</FONT></B>") );
		}
	} else {
		sends_P( txt_time_void );
	}
	sends_P( PSTR("</TD><TD>&nbsp;</TD></TR>") );

	if ( netInfo.ddnsMode ) {
		/* _Ci~bNDNSXVURL		*/
		eep_read_ddns_update_url( lp->msg ,URL_SIZE );
		sends_P( PSTR("<TR><TD>&nbsp;Update&nbsp;DDNS&nbsp;url</TD><TD>&nbsp;") );
		sends( lp->msg );
		sends_P( PSTR("</TD><TD><div style=\"text-align:center\"><A href=\"edit_ddnsurl.html\" target=\"_self\" style=\"text-decoration:none;\">") );
		sends_P( txt_Edit );
		sends_P( PSTR("</A></div></TD></TR>") );

		/* _Ci~bNDNS ŏIXV	*/
		sends_P( PSTR("<TR><TD>&nbsp;DDNS&nbsp;last&nbsp;update</TD><TD>&nbsp;") );
		if ( netInfo.ddnsLastUpdate ) {
			ntpc_setTimeStruct( netInfo.ddnsLastUpdate ,&lp->t );
			sprintf_P( lp->msg ,fmt_time ,lp->t.year ,lp->t.month ,lp->t.day ,lp->t.hour ,lp->t.minute ,lp->t.second );
			sends( lp->msg );
			if ( netInfo.ddnsLastUpdate_sts == 2 ) {
				sends_P( PSTR("&nbsp;<B><FONT color=\"#ff0000\">(Failure&nbsp;!)</FONT></B>") );
			}
		} else {
			sends_P( txt_time_void );
		}
		sends_P( PSTR("</TD><TD>&nbsp;</TD></TR>") );

		/* DDNS/ŌɍXVIPAhX*/
		strcpy_s_P( lp->txt1 ,sizeof(lp->txt1) ,PSTR("DDNS&nbsp;last&nbsp;update&nbsp;IP") );
		inet_ntoa( lp->txt2 ,netInfo.ddnsLastUpdateIpAddress );
		sprintf_P( lp->msg ,fmt_textRow ,lp->txt1 ,lp->txt2 );
		sends( lp->msg );
	}

	sends_P( table_end );
}

/*****************************************************************************
*								ddns.html
* Fchar    *pCmd R}hւ̃|C^
* ߒlFvoid
*****************************************************************************/
static void html_ddns( char *pCmd )
{
	netInfo.ddnsMode ^= 1;
	if ( netInfo.ddnsMode ) {
		sends_P( PSTR("<P><B><FONT color=\"#0000ff\">DDNS&nbsp;is&nbsp;Enable</FONT></B></P>") );
	} else {
		sends_P( PSTR("<P><B><FONT color=\"#ff0000\">DDNS&nbsp;is&nbsp;Disable</FONT></B></P>") );
	}
	ddns_init();
}

/*****************************************************************************
*								etB[hҏW
* Fchar            *data       ҏWf[^obt@
*		uint8_t         buffer_size ҏWf[^obt@TCY
*		const prog_char *label      ҏWeLXgږ
*		char            *pCmd       R}hւ̃|C^
* ߒlFuint8_t                     0:ύX 1:ύXL
*****************************************************************************/
static uint8_t html_textEdit( char *data ,uint8_t buffer_size ,const prog_char *label ,char *pCmd )
{
	uint8_t button;
	uint8_t update = 0;
	char editText[ URL_SIZE ] ,buf[ URL_SIZE + 2 ];

	/* p[^擾				*/
	button = ( getCommandItem( pCmd ,PSTR("set") ,sizeof(buf) ,buf ) == 0 );
	if ( !button ) {
		strcpy_s( editText ,buffer_size ,data );
	} else {
		getCommandItem( pCmd ,PSTR("val") ,sizeof(buf) ,buf );
		if ( strlen( buf ) < sizeof(editText) ) {
			strcpy_s( editText ,sizeof(editText) ,buf );
			decode( editText );
			strtrim( editText );
		} else {
			sends_P( PSTR("<P><B><FONT color=\"#ff0000\">It&nbsp;is&nbsp;an&nbsp;invalid&nbsp;parameter.</FONT></B></P>") );
			return ( 0 );
		}
	}

	/* Cvbg{bNX쐬		*/
	sends_P( PSTR("<form>") );
	sends_P( label );
	sprintf_P( buf ,PSTR(":<BR><INPUT type=\"text\" maxlength=\"%d\" style=\"WIDTH: 400px\" value=\"") ,buffer_size - 1 );
	sends( buf );
	sends( editText );
	sends_P( PSTR("\" name=\"val\"><BUTTON style=\"WIDTH: 60px\" type=\"submit\" name=\"set\">OK</BUTTON>") );
	sprintf_P( buf ,PSTR("<BR>a&nbsp;maximum&nbsp;of&nbsp;%d&nbsp;characters") ,buffer_size - 1 );
	sends( buf );
	sends_P( PSTR("</form>") );

	/* f[^ύX					*/
	if ( button ) {
		if ( editText[0] == '\0' ) {
			sends_P( PSTR("<P><B><FONT color=\"#ff0000\">[") );
			sends_P( label );
			sends_P( PSTR("]&nbsp;uninputted&nbsp!</FONT></B></P>") );
		} else {
			if ( strcmp( editText ,data ) != 0 ) {
				strcpy_s( data ,buffer_size ,editText );
				update = 1;
			}
			sends_P( PSTR("<P><B><FONT color=\"#00ff00\">[") );
			sends_P( label );
			sends_P( PSTR("]&nbsp;succeeded&nbsp!</FONT></B></P>") );
		}
	}

	return ( update );
}

/*****************************************************************************
*					R}hp[^wACe擾
* Fchar       *pCmd R}h
*       const char *name ACe
*		uint16_t   size  obt@TCY
*		char       *buf  obt@
* ߒlFuint8_t          0:OK !0:wACe
*****************************************************************************/
static uint8_t getCommandItem( char *pCmd ,const char *name ,uint16_t size ,char *buf )
{
	char *p1;
	char *p2 = buf;

	*p2 = '\0';
	size--;

	/* ACe		*/
	p1 = strcasestr_P( pCmd ,name );
	if ( p1 == NULL ) {
		return ( 1 );
	}

	/* = 				*/
	p1 = strchr( p1 + strlen_P( name ) ,'=' );
	if ( p1 == NULL ) {
		return ( 2 );
	}
	p1++;

	/* ACe񒷎擾	*/
	while ( size-- && *p1 && ( *p1 != '&' ) ) {
		*p2++ = *p1++;
	}
	*p2 = '\0';
	strtrim( buf );

	return ( 0 );
}

/*****************************************************************************
*						\Pbg֕PʂőM
* Fconst prog_char *txt
* ߒlFvoid
* Z𑗐MƃX傫Ȃ̂Œ
*****************************************************************************/
static void sends_P( const prog_char *txt )
{
	if ( !sendSts ) {
		uint16_t len = strlen_P( txt );
		sendSts |= tcp_send_P( HTTPS_SOCK ,txt ,len );
	}
}

static void sends( char *txt )
{
	if ( !sendSts ) {
		uint16_t len = strlen( txt );
		sendSts |= tcp_send( HTTPS_SOCK ,txt ,len );
	}
}

/*****************************************************************************
*				uEU瑗Ă%t̕fR[h
* Fchar *txt
* ߒlFvoid
*****************************************************************************/
static void decode( char *txt )
{
	char *p = txt;
	char buf[ 4 ];
	uint16_t val = 0;

	while ( *p ) {
		if ( ( *p == '%' ) && ( strlen( p ) >= 3 ) ) {
			memcpy( buf ,p + 1 ,2 );
			buf[ 2 ] = '\0';
			if ( htou16( buf ,&val ) == 0 ) {
				*p = (char)val;
				strcpy( p + 1 ,p + 3 );
			}
		}
		p++;
	}
}
