/*###############################################################################################
#                                                                          					    #
#                               J_[֘AW[    	          					    #
#                                                                          					    #
# CEX -> OSIϊASYQlURL											#
# http://delfusa.main.jp/delfusafloor/archive/www.nifty.ne.jp_forum_fdelphi/samples/00850.html	#
#                                                                                               #
###############################################################################################*/
#ifndef __DATE_H__
#define __DATE_H__

#include <avr/io.h>

/* ֐gp^gpݒ			*/
#define __USE_DATE_DAY2WEEK__    1
#define __USE_DATE_GREG2MJD__    1
#define __USE_DATE_MJD2GREG__    1
#define __USE_DATE_DAYSOFMONTH__ 1

/* [N}N				*/
#define IS_LEAP_YEAR(y) ( (!(y % 400)) || ( (y % 100) && (!(y % 4)) ) )

/* w̔N܂łɗL[N̉	*/
#define LEAPS_THRU_END_OF(y)	( ( (y) / 4 ) - ( (y) / 100 ) + ( (y) / 400 ) )

/* ֐vg^Cv錾			*/
#if ( __USE_DATE_DAY2WEEK__ )
uint8_t date_day2week( uint16_t y ,uint8_t m ,uint8_t d );
#endif

#if ( __USE_DATE_GREG2MJD__ )
uint32_t date_greg2mjd( uint16_t year ,uint8_t month ,uint8_t day );
#endif

#if ( __USE_DATE_MJD2GREG__ )
void date_mjd2greg( uint32_t mjd ,uint16_t *year ,uint8_t *month ,uint8_t *day ,uint8_t *wday );
#endif

#if ( __USE_DATE_DAYSOFMONTH__ )
uint8_t date_daysOfMonth( uint16_t year ,uint8_t month );
#endif

#endif
