/*###########################################################################
#                                                                           #
#								񑀍֐Q						@@#
#                                                                           #
#                                            2012.12.08 strcpy_s() ֐C #
###########################################################################*/
#ifndef __STRING_FUNC_H__
#define __STRING_FUNC_H__

#include <avr/io.h>
#include <avr/pgmspace.h>

#define USE_ISDECIMALNUMBER 1
#define USE_ISHEXNUMBER     1

#define USE_ISDECIMALNUMBERSTRING 1
#define USE_ISHEXNUMBERSTRING 1

#define USE_ATOU16       1
#define USE_HTOU16       1

#define USE_UTOA_KANMA   0

#define USE_TRIM         1

#define USE_INSTRREV     0
#define USE_GETFILENAME  0
#define USE_GETEXTENSION 0
#define USE_GETFILEPATH  0

#define USE_GETCHARCODE  0
#define USE_GETCHARCODE  0

#define USE_STRCAT_S     1
#define USE_STRCPY_S     1

#ifndef NULL
#define NULL (void *)0
#endif

/*	S-JIS1oCgڃ`FbN	*/
#ifndef IS_SJIS1
#define IS_SJIS1(code) ( ( ( (uint8_t)(code) >= 0x81 ) && ( (uint8_t)(code) <= 0x9f ) ) || ( ( (uint8_t)(code) >= 0xe0 ) && ( (uint8_t)(code) <= 0xfc ) ) )
#endif

/*	S-JIS2oCgڃ`FbN	*/
#ifndef IS_SJIS2
#define IS_SJIS2(code) ( ( ( (uint8_t)(code) >= 0x40 ) && ( (uint8_t)(code) <= 0x7e ) ) || ( ( (uint8_t)(code) >= 0x80 ) && ( (uint8_t)(code) <= 0xfc ) ) )
#endif

/* ֐vg^Cv錾						*/
uint8_t isDecimalNumber( char c );
uint8_t isHexNumber( char c );
uint8_t isDecimalNumberString( char *str );
uint8_t isHexNumberString( char *str );
uint8_t atou16( char *str ,uint16_t *val );
uint8_t htou16( char *str ,uint16_t *val );
void utoa_kanma( uint32_t n ,char *s ,uint8_t k );
void strtrim( char *s );
char *getFileName( char *path );
char *getExtension( char *path );
void getFilePath( char *fname ,char *path );
char *inStrRev( char *s ,char c );
uint16_t getCharCode( char **s );
uint16_t getCharCode_P( prog_char **s );
uint8_t strcat_s( char *strDestination ,uint16_t numberOfElements ,char *strSource );
uint8_t strcat_s_P( char *strDestination ,uint16_t numberOfElements ,const prog_char *strSource );
uint8_t strcpy_s( char *strDestination ,uint16_t numberOfElements ,char *strSource );
uint8_t strcpy_s_P( char *strDestination ,uint16_t numberOfElements ,const prog_char *strSource );

#endif
