/*############################################################################
#                                                                            #
#   		          lbg[Np[eBeB      			         #
#                                                                            #
############################################################################*/
#ifndef __NET_UTIL_H__
#define __NET_UTIL_H__

#include <avr/io.h>

#define USE_MAC_ADDR       0
#define USE_IS_DOMAIN      0
#define USE_URL_DISMANTLED 1

#if ( USE_URL_DISMANTLED == 1 )
typedef struct URL_t {
	char *scheme;
	char *domain;
	char *file;
	char *para;
	uint16_t port;
} URL;
#endif

/* ֐vg^Cv錾			*/
#if ( USE_IS_DOMAIN == 1 )
uint8_t isDomain( char *str );
#endif

#if ( USE_MAC_ADDR == 1 )
uint8_t mac_addr( char *str ,uint8_t *mac );
#endif

#if ( USE_URL_DISMANTLED == 1 )
void urlDismantled( char *url ,URL *u );
#endif

uint16_t swapByteorder16( uint16_t val );
uint32_t swapByteorder32( uint32_t val );
void mcu_soft_reset( void );
void inet_ntoa( char *str ,uint32_t addr );
uint32_t inet_addr( char *addr );

#endif
