/*###########################################################################
#                                                                           #
#                        WOLubWpPbg				            #
#                                                                           #
###########################################################################*/
#define __WOL_C__

#include <string.h>
#include <avr/io.h>

#include "net.h"
#include "wol.h"

/*****************************************************************************
*								WOLubW
* Fvoid
* ߒlFvoid
*****************************************************************************/
void wol_init( void )
{
	memset( (void *)&wolInfo.mac ,0x00 ,sizeof(WOL_INFO) );
}

/*****************************************************************************
*								WOLubW ^XN
* Fvoid
* ߒlFvoid
*****************************************************************************/
void wol_task( void )
{
	uint16_t port;
	uint32_t ip;
	uint16_t len;
	uint8_t i;

	uint8_t dat[ WOL_PACKET_SIZE ] ,*p;
	uint8_t chk[ WOL_HEADER_LENGTH + MAC_ADDRESS_LENGTH ];

	/* \PbgI[v				*/
	if ( ( wiz_getSn_SR( WOL_SOCK ) != SOCK_UDP ) || ( wiz_getSn_SPORT( WOL_SOCK ) != netInfo.wolPort ) ) {
		if ( udp_open( WOL_SOCK ,netInfo.wolPort ) != SOCK_UDP ) {
			return;
		}
	}

	/* f[^M					*/
	len = udp_recvfrom( WOL_SOCK ,dat ,WOL_PACKET_SIZE ,&ip ,&port );
	if ( len != WOL_PACKET_SIZE ) {
		return;
	}

	p = dat;

	memset( chk ,0xff ,WOL_HEADER_LENGTH );		/* 擪6oCgS0xffł邱			*/
	if ( memcmp( p ,chk ,WOL_HEADER_LENGTH ) != 0 ) {
		return;
	}
	p += WOL_HEADER_LENGTH;

	memcpy( chk ,p ,MAC_ADDRESS_LENGTH );
	p += MAC_ADDRESS_LENGTH;

	for ( i = 1 ;i < MAC_REPEAT_COUNT ;i++ ) {	/* MACAhX16AĂ邱	*/
		if ( memcmp( p ,chk ,MAC_ADDRESS_LENGTH ) != 0 ) {
			return;
		}
		p += MAC_ADDRESS_LENGTH;
	}

	p = &dat[ WOL_HEADER_LENGTH ];
	memset( chk ,0xff ,MAC_ADDRESS_LENGTH );/* MACAhXff-ff-ff-ff-ff-ffŖ	*/ 
	if ( memcmp( p ,chk ,MAC_ADDRESS_LENGTH ) == 0 ) {
		return;
	}

	memset( chk ,0x00 ,MAC_ADDRESS_LENGTH );/* MACAhX00-00-00-00-00-00Ŗ	*/ 
	if ( memcmp( p ,chk ,MAC_ADDRESS_LENGTH ) == 0 ) {
		return;
	}

	/* u[hLXgɃ}WbNpPbgM	*/
	ip = 0xffffffff;
	port = netInfo.wolPort;
	udp_sendto( WOL_SOCK ,dat ,WOL_PACKET_SIZE ,ip ,port );

	/* WOLM`Xe[^Xݒ			*/
	wolInfo.blinkCount = 50;								/* 傫lقLCDobNCg̓_ŎԂȂ	*/
	memcpy( (void *)wolInfo.mac ,p ,MAC_ADDRESS_LENGTH );
	wolInfo.lastTime = ntpcInfo.systemTime;
}
