/*############################################################################
#                                                                          	 #
#                       Cj[ʊ֘AW[                     #
#                                                                          	 #
############################################################################*/
#define __MENU00_C__
#include "project.h"

/*****************************************************************************
*							Cj[
* Fuint8_t itemIndex		0:ݓ
*								1:|[gԍ
*								2:DHCP샂[h
*								3:[JIPAhX
*								4:Tulbg}XN
*								5:[^[AhX
*								6:DNST[o[AhX
*                               7:WANIPAhX
*                               8:[JzXg
*                               9:NTPT[o[
*                              10:MACAhX
* ߒlFuint8_t ̃XN[ԍ
*****************************************************************************/
uint8_t main_screen( uint8_t itemIndex )
{
	static const uint8_t itemCount = 11;

	static const prog_char item01[] = "Port Number";
	static const prog_char item02[] = "DHCP Mode";
	static const prog_char item03[] = "Local IP Address";
	static const prog_char item04[] = "Sub Net Mask";
	static const prog_char item05[] = "Router Address";
	static const prog_char item06[] = "DNS Address";
	static const prog_char item07[] = "WAN IP Address";
	static const prog_char item08[] = "Local Host Name";
	static const prog_char item09[] = "NTP Host Name";
	static const prog_char item10[] = "MAC Address";
	static const prog_char *menu[] PROGMEM = { NULL ,item01 ,item02 ,item03 ,item04 ,item05 ,item06 ,item07 ,item08 ,item09 ,item10 };

	char txt[2][17];
	char data[4];
	uint8_t timeout = 0;
	uint8_t update = 0;
	uint8_t ky;
	TIME t;

	uint8_t flip = 0;
	sys_tick300msec = 1;
	sys_count300msec = 0;

	/* C[v				*/
	while ( 1 ) {
		wdt_reset();

		/* ʕ\				*/
		if ( sys_tick300msec ) {
			if ( timeout <= 100 ) {
				++timeout;
			} else {
				itemIndex = 0;
			}
			sys_tick300msec = 0;

			for ( uint8_t i = 0 ;i < 2 ;i++ ) {
				memset( txt[i] ,' ' ,16 );
				txt[i][16] = '\0';
			}

			if ( itemIndex != 0 ) {
				memcpy_P( txt[0] ,(prog_char *)pgm_read_word( &menu[ itemIndex ] ) ,strlen_P( (prog_char *)pgm_read_word( &menu[ itemIndex ] ) ) );
			}

			if ( itemIndex == 0 ) {					/* ݎ\			*/
				if ( net_task_status() != 0xff ) {
					strcpy_s_P( txt[0] ,sizeof(txt[0]) ,project_title );
					if ( flip == 0 ) {
						strcpy_P( txt[1] ,PSTR(" initialization ") );
					}
				} else {
					ntpc_getTime( &t );
					make_dateTime_screenText( &t ,txt[0] ,txt[1] );
				}

			} else if ( itemIndex == 1 ) {			/* |[gԍ			*/
				sprintf_P( &txt[1][11] ,PSTR("%5u") ,netInfo.wolPort );

			} else if ( itemIndex == 2 ) {			/* DHCP샂[h\	*/
				if ( netInfo.dhcpMode == IP_STATIC ) {
					memcpy_P( &txt[1][13] ,PSTR("OFF") ,3 );
				} else {
					memcpy_P( &txt[1][14] ,PSTR("ON") ,2 );
				}

			} else if ( itemIndex == 3 ) {			/* [JIPAhX	*/
				*(uint32_t *)data = netInfo.ip;

			} else if ( itemIndex == 4 ) {			/* Tulbg}XN		*/
				*(uint32_t *)data = netInfo.subnet;

			} else if ( itemIndex == 5 ) {			/* Q[gEGCAhX	*/
				*(uint32_t *)data = netInfo.gateway;

			} else if ( itemIndex == 6 ) {			/* DNST[o[AhX	*/
				*(uint32_t *)data = netInfo.dns;

			} else if ( itemIndex == 7 ) {			/* WANIPAhX		*/
				*(uint32_t *)data = netInfo.checkIpAddress;

			} else if ( itemIndex == 8 ) {			/* [JzXg		*/
				memcpy( txt[1] ,netInfo.hostname ,strlen( netInfo.hostname ) );

			} else if ( itemIndex == 9 ) {			/* NTPT[o[		*/
				uint8_t len = strlen( netInfo.ntpcName );
				if ( len > 16 ) len = 16;
				memcpy( txt[1] ,netInfo.ntpcName ,len );

			} else if ( itemIndex == 10 ) {			/* MACAhX			*/
				sprintf_P( &txt[1][3] ,PSTR("%02X%02X%02X-%02X%02X%02X") ,netInfo.mac[0] ,netInfo.mac[1] ,netInfo.mac[2] ,netInfo.mac[3] ,netInfo.mac[4] ,netInfo.mac[5] );

			}

			if ( ( itemIndex >= 3 ) && ( itemIndex <= 7 ) ) {
				sprintf_P( &txt[1][1] ,PSTR("%3u.%3u.%3u.%3u") ,data[0] ,data[1] ,data[2] ,data[3] );
			}

		}

		for ( uint8_t i = 0 ;i < 2 ;i++ ) {
			lcdLocate( i ,0 );
			lcdPuts( txt[i] );
		}
		flip ^= 1;

		/* lbg[N^XN		*/
		net_task();

		/* {^			*/
		update = 0;
		ky = keysInkey();
		if ( ky == KEY_UP ) {
			if ( --itemIndex == 0xff ) {
				itemIndex = itemCount - 1;
			}
			update = 1;

		} else if ( ky == KEY_DOWN ) {
			if ( ++itemIndex >= itemCount ) {
				itemIndex = 0;
			}
			update = 1;

		} else if ( ky == KEY_LEFT ) {				/* obNCgPx -		*/
			uint16_t v = (uint16_t)OCR0A + 25;
			if ( v > 255 ) {
				v = 255;
			}
			OCR0A = (uint8_t)v;

		} else if ( ky == KEY_RIGHT ) {				/* obNCgPx +		*/
			uint16_t v = (uint16_t)OCR0A - 25;
			if ( v > 255 ) {
				v = 0;
			}
			OCR0A = (uint8_t)v;

		} else if ( ky == KEY_ENTER ) {				/* Enter : [h֋J / LCDZbg	*/
			lcdInit( ON );
			itemIndex = 0;
			update = 1;

		} else if ( ky == ( KEY_ENTER | KEY_LONGPUSH_START ) ) {
			if ( itemIndex == 0 ) {					/* j[			*/
				itemIndex = 110;
			} else if ( itemIndex == 1 ) {			/* |[gԍύXj[	*/
				itemIndex = 121;
			} else if ( itemIndex == 2 ) {			/* DHCP[hؑփj[	*/
				itemIndex = 122;
			}

			if ( netInfo.dhcpMode == IP_STATIC ) {	/* DHCP̂	*/
				if ( itemIndex == 3 ) {				/* [JIPύXj[	*/
					itemIndex = 123;
				} else if ( itemIndex == 4 ) {		/* TulbgύXj[	*/
					itemIndex = 124;
				} else if ( itemIndex == 5 ) {		/* [^[ύXj[	*/
					itemIndex = 125;
				} else if ( itemIndex == 6 ) {		/* DNSύXj[		*/
					itemIndex = 126;
				}
			}

			if ( itemIndex > 100 ) {
				break;
			}
		}

		if ( update ) {
			sys_count300msec = 0;
			sys_tick300msec = 1;
			flip = 0;
			timeout = 0;
		}
	}

	return ( itemIndex );
}
