/*############################################################################
#                                                                          	 #
#                       j[ʊ֘AW[   	                     #
#                                           `lbg[Nݒ֘A`      	 #
#                                                                          	 #
############################################################################*/
#define __MENU2X_C__
#include "project.h"

/*****************************************************************************
*							|[gԍύX
* Fvoid
* ߒlFvoid
*****************************************************************************/
void sub_screen121( void )
{
	uint8_t update;
	uint8_t cursol = 4;
	uint8_t ky;
	uint32_t port;
	char lcd[8] ,txt[8];

	uint8_t flip = 0;
	sys_tick300msec = 1;
	sys_count300msec = 0;

	/* ݂̃|[gԍ擾		*/
	sprintf_P( txt ,PSTR("%05u") ,netInfo.wolPort );

	/* C[v					*/
	while ( 1 ) {
		wdt_reset();

		/* ʕ\					*/
		if ( sys_tick300msec ) {
			strcpy( lcd ,txt );
			if ( flip ) {
				lcd[ cursol ] = ' ';
			}
			lcdLocate( 1 ,11 );
			lcdPuts( lcd );
			sys_tick300msec = 0;
			flip ^= 1;
		}

		/* lbg[N^XN		*/
		net_task();

		/* L[					*/
		update = 0;
		ky = keysInkey();
		if ( ky == KEY_ENTER ) {
			port = atol( txt );
			if ( ( port > 0L ) && ( port < 65536L ) ) {
				break;
			}

		} else if ( ky == KEY_UP ) {
			txt[ cursol ]++;
			if ( txt[ cursol ] > '9' ) {
				txt[ cursol ] = '0';
			}
			flip = 0;
			update = 1;

		} else if ( ky == KEY_DOWN ) {
			txt[ cursol ]--;
			if ( txt[ cursol ] < '0' ) {
				txt[ cursol ] = '9';
			}
			flip = 0;
			update = 1;

		} else if ( ky == KEY_LEFT ) {
			cursol--;
			if ( cursol == 0xff ) {
				cursol = 4;
			}
			flip = 1;
			update = 1;

		} else if ( ky == KEY_RIGHT ) {
			cursol++;
			if ( cursol > 4 ) {
				cursol = 0;
			}
			flip = 1;
			update = 1;
		}

		if ( update ) {
			sys_tick300msec = 1;
			sys_count300msec = 0;
		}
	}

	/* EEP֐ݒlEEP֏			*/
	if ( netInfo.wolPort != (uint16_t)port ) {
		netInfo.wolPort = (uint16_t)port;
		eep_write_netInfo();
	}
}

/*****************************************************************************
*							DHCP샂[hύX
* Fvoid
* ߒlFvoid
*****************************************************************************/
void sub_screen122( void )
{
	uint8_t update;
	uint8_t ky;
	uint8_t sw;
	char lcd[8];

	uint8_t flip = 0;
	sys_tick300msec = 1;
	sys_count300msec = 0;

	/* ݂DHCP샂[h擾	*/
	sw = netInfo.dhcpMode;

	/* C[v					*/
	while ( 1 ) {
		wdt_reset();

		/* ʕ\					*/
		if ( sys_tick300msec ) {
			strcpy_P( lcd ,PSTR("ON / OFF") );
			if ( flip ) {
				if ( sw == IP_STATIC ) {
					memset( &lcd[5] ,' ' ,3 );
				} else {
					memset( &lcd[0] ,' ' ,2 );
				}
			}
			lcdLocate( 1 ,8 );
			lcdPuts( lcd );
			sys_tick300msec = 0;
			flip ^= 1;
		}

		/* lbg[N^XN		*/
		net_task();

		/* L[					*/
		update = 0;
		ky = keysInkey();
		if ( ky == KEY_ENTER ) {
			break;

		} else if ( ( ky == KEY_LEFT ) || ( ky == KEY_RIGHT ) ) {
			sw ^= 1;
			flip = 1;
			sys_tick300msec = 1;
			sys_count300msec = 0;
		}
	}

	/* EEP֐ݒlEEP֏			*/
	if ( netInfo.dhcpMode != sw ) {
		netInfo.dhcpMode = sw;
		eep_write_netInfo();
		net_init();
	}
}

/*****************************************************************************
*							eIPAhXύX
* Fuint8_t type 1 [JIP
*					 2 Tulbg
*				     3 [^[iQ[gEGCj
*                    4 DNS
* ߒlFvoid
*****************************************************************************/
void sub_screen123( uint8_t type )
{
	uint8_t update;
	uint8_t cursol = 11;
	uint8_t ky;
	uint8_t pos;
	uint8_t *p;
	uint32_t ip;
	char lcd[18] ,txt[18];

	uint8_t flip = 0;
	sys_tick300msec = 1;
	sys_count300msec = 0;

	/* ݂̒l擾				*/
	if ( type == 1 ) {
		ip = netInfo.ip;
	} else if ( type == 2 ) {
		ip = netInfo.subnet;
	} else if ( type == 3 ) {
		ip = netInfo.gateway;
	} else if ( type == 4 ) {
		ip = netInfo.dns;
	} else {
		return;
	}

	p = (uint8_t *)&ip;
	sprintf_P( txt ,PSTR("%03u.%03u.%03u.%03u") ,p[0] ,p[1] ,p[2] ,p[3] );

	/* C[v					*/
	while ( 1 ) {
		wdt_reset();

		/* J[\ʒuvZ			*/
		pos = ( ( cursol / 3 ) * 4 ) + ( cursol % 3 );

		/* ʕ\					*/
		if ( sys_tick300msec ) {
			strcpy( lcd ,txt );
			if ( flip ) {
				lcd[ pos ] = ' ';
			}
			lcdLocate( 1 ,1 );
			lcdPuts( lcd );
			sys_tick300msec = 0;
			flip ^= 1;
		}

		/* lbg[N^XN		*/
		net_task();

		/* L[					*/
		update = 0;
		ky = keysInkey();
		if ( ky == KEY_ENTER ) {
			ip = inet_addr( txt );
			if ( ( ip != 0L ) && ( ip != 0xffffffff ) && ( p[3] != 0xff ) ) {
				if ( ( type == 2 ) || ( p[3] != 0x00 ) ) {
					break;
				}
			}

		} else if ( ky == KEY_UP ) {
			txt[ pos ]++;
			if ( txt[ pos ] > '9' ) {
				txt[ pos ] = '0';
			}
			flip = 0;
			update = 1;

		} else if ( ky == KEY_DOWN ) {
			txt[ pos ]--;
			if ( txt[ pos ] < '0' ) {
				txt[ pos ] = '9';
			}
			flip = 0;
			update = 1;

		} else if ( ky == KEY_LEFT ) {
			cursol--;
			if ( cursol == 0xff ) {
				cursol = 11;
			}
			flip = 1;
			update = 1;

		} else if ( ky == KEY_RIGHT ) {
			cursol++;
			if ( cursol > 11 ) {
				cursol = 0;
			}
			flip = 1;
			update = 1;
		}

		if ( update ) {
			sys_tick300msec = 1;
			sys_count300msec = 0;
		}
	}

	/* EEP֐ݒlEEP֏			*/
	update = 0;
	if ( type == 1 ) {
		if ( ip != netInfo.ip ) {
			netInfo.ip = ip;
			wiz_setSIPR( (uint8_t *)&netInfo.ip );
			update = 1;
		}
	} else if ( type == 2 ) {
		if ( ip != netInfo.subnet ) {
			netInfo.subnet = ip;
			wiz_setSUBR( (uint8_t *)&netInfo.subnet );
			update = 1;
		}

	} else if ( type == 3 ) {
		if ( ip != netInfo.gateway ) {
			netInfo.gateway = ip;
			wiz_setGAR( (uint8_t *)&netInfo.gateway );
			update = 1;
		}

	} else if ( type == 4 ) {
		if ( ip != netInfo.dns ) {
			netInfo.dns = ip;
			update = 1;
		}
	}

	if ( update ) {
		eep_write_netInfo();
	}
}
