/*###########################################################################
#                                                                           #
#                        WOLubW wb_[				            #
#                                                                           #
###########################################################################*/
#ifndef __PROJECT_H__
#define __PROJECT_H__

#define MAX_YEAR 2099
#define MIN_YEAR 2010

#define DELAULT_WOL_PORT 51000U

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/eeprom.h>
#include <avr/wdt.h>
#include <avr/pgmspace.h>
#include <util/delay.h>

#include "SC1602/lcd.h"

#include "AT93C46D/at93c46d.h"

#include "KEYS/keys.h"

#include "W5100/net.h"

#include "myutil/date.h"
#include "myutil/crc.h"
#include "myutil/string_func.h"

#include "etc_funcs.h"
#include "menu.h"

/* ~bJEgɕϊ( F_CPU / 1024 ŌvZ ) */
#define TIMER_MS_TO_COUNT(tim) ( (uint16_t)( ( ( F_CPU / 1024L ) * (uint32_t)tim ) / 1000L ) )

/* O[oϐ								*/
#ifdef __MAIN_C__
volatile uint8_t sys_tick300msec = 0;
volatile uint8_t sys_count300msec = 0;
//	vWFNg^Cg	   0000000001111111
//	16Œ					   1234567890123456
const prog_char project_title[] = "WOL Bridge v1.00";

#else
extern volatile uint8_t sys_tick300msec;
extern volatile uint8_t sys_count300msec;
extern const prog_char project_title[];
#endif

#endif
